﻿using System;
using System.Windows;
using System.Windows.Media.Imaging;
using Microsoft.Windows.Controls.Ribbon;
using ThinkGeo.MapSuite.GisEditor;
using ThinkGeo.MapSuite.Core;

namespace SampleUIPlugin
{
    public class SampleUIPlugin : UIPlugin
    {
        private RibbonEntry entry;

        public SampleUIPlugin()
        { }

        protected override void LoadCore()
        {
            base.LoadCore();

            if (entry == null)
            {
                RibbonGroup ribbonGroup = GetRibbonGroup();
                entry = new RibbonEntry(ribbonGroup);
                RibbonEntries.Add(entry);
            }
        }

        protected override void UnloadCore()
        {
            base.UnloadCore();

            RibbonEntries.Clear();
        }

        public static void ShowOverlayCount(object sender, RoutedEventArgs e)
        {
            // add google layer logic

            // method 1: using the default without the Api key or clientId, limitation: 1 000 Static Maps requests per IP address per 24 hour period.
            GoogleMapsLayer googlelayer = new GoogleMapsLayer();
            // method 2: using Api key, limitation: 25 000 Static Maps requests per 24 hour period.
            googlelayer.CreatingRequest += new EventHandler<CreatingRequestGoogleMapsLayerEventArgs>(googlelayer_CreatingRequest);
            // method 3: using the request for business with ClientId, No limitation
            //googlelayer.ClientId = "xxx";
            //googlelayer.PrivateKey = "xxx";
            GisEditor.ActiveMap.AddLayersToActiveOverlay(new Layer[] { googlelayer });
            GisEditor.ActiveMap.Refresh();
            GisEditor.UIManager.RefreshPlugins();
        }

        static void googlelayer_CreatingRequest(object sender, CreatingRequestGoogleMapsLayerEventArgs e)
        {
            e.RequestUri = new Uri(e.RequestUri.AbsoluteUri + "&key={API_KEY}");
        }

        private RibbonGroup GetRibbonGroup()
        {
            RibbonButton button = new RibbonButton();
            button.Label = "Add Google Layer";
            button.LargeImageSource = new BitmapImage(new Uri("/SampleUIPlugin;component/Images/showInfo.png", UriKind.Relative));
            button.SmallImageSource = new BitmapImage(new Uri("/SampleUIPlugin;component/Images/showInfo.png", UriKind.Relative));
            button.Click += ShowOverlayCount;

            RibbonGroup group = new RibbonGroup();
            group.Header = "Google layer";
            group.Items.Add(button);

            return group;
        }
    }
}